Object subclass: #Club
	instanceVariableNames: 'nombreDelClub tarifaSocio tarifaSocioVIP recaudacionTotal conjuntoSocios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tp0.5-Test'!

!Club methodsFor: 'initialization' stamp: 'RodrigoVargas 4/29/2020 01:59'!
initialize

	nombreDelClub := ''.
	tarifaSocio := 0.
	tarifaSocioVIP := 0.
	recaudacionTotal := 0.
	conjuntoSocios := Set new.
	! !


!Club methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/29/2020 04:11'!
nombresSocios 
	^ (conjuntoSocios collect: [ :unSocio| unSocio darNombre ])! !

!Club methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/29/2020 05:00'!
recibirPagoDe: unNombre
	self cobrar:( self encontrarSocio: unNombre ).! !

!Club methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/29/2020 02:01'!
agregarSocioVIP: unSocio

	conjuntoSocios add: (unSocio).
	unSocio establecerTarifa: tarifaSocioVIP .! !

!Club methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/29/2020 03:48'!
agregarSocio: unSocio

	conjuntoSocios add: (unSocio) .
	unSocio establecerTarifa: tarifaSocio .! !

!Club methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/29/2020 02:01'!
cantidadDeSocios 
	^((conjuntoSocios)size).! !

!Club methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/29/2020 04:07'!
encontrarSocio: unNombre

	^ 	( conjuntoSocios detect: [ :unSocio| unSocio darNombre = unNombre ] ).! !

!Club methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/29/2020 04:22'!
cantidadPagadaPor: unNombre
	|socio|
	socio:= self encontrarSocio: unNombre.
	^ (socio darTarifa * socio cantidadDePagos) ! !

!Club methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/29/2020 04:40'!
cobrar: unSocio
	unSocio realizoUnPago.
	recaudacionTotal := recaudacionTotal + unSocio darTarifa .
	! !

!Club methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/27/2020 08:48'!
recaudacionTotal
	^recaudacionTotal.! !


!Club methodsFor: 'setter' stamp: 'RodrigoVargas 4/27/2020 08:35'!
establecerTarifaSocioVIP: unaTarifa

	tarifaSocioVIP := unaTarifa .! !

!Club methodsFor: 'setter' stamp: 'RodrigoVargas 4/27/2020 08:34'!
establecerTarifaSocio: unaTarifa

	tarifaSocio := unaTarifa .! !

!Club methodsFor: 'setter' stamp: 'RodrigoVargas 4/27/2020 08:33'!
establecerNombre: unNombre

	nombreDelClub := unNombre .! !


TestCase subclass: #PruebasClub
	instanceVariableNames: 'club'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tp0.5-Test'!
!PruebasClub commentStamp: 'tomas 4/25/2020 11:52' prior: 0!
Pruebas unitarias del Club Social y Deportivo Orientado a Objetos!


!PruebasClub methodsFor: 'tests' stamp: 'tomas 4/25/2020 11:47'!
test11SeAgreganDosSociosComunesYOtroVipYRealizanSietePagosComunYLaCantidadPagadaPorElSegundoSocioComunEs1500
	" Arrange "
	| socio1 socio2 socio3 cantidadPagada |
	
	socio1 := Socio new.
	socio1 establecerNombre: 'Carlos'.

	socio2 := Socio new.
	socio2 establecerNombre: 'Marcio'.

	socio3 := Socio new.
	socio3 establecerNombre: 'Pablo'.

	club agregarSocio: socio1; agregarSocioVIP: socio2; agregarSocio: socio3.
	
	4 timesRepeat: [ 
		club recibirPagoDe: 'Carlos'. " 500 "
		club recibirPagoDe: 'Marcio'. " 700 "
	].

	3 timesRepeat: [ 
		club recibirPagoDe: 'Pablo'.  " 500 "
	].
	
	" Act "
	cantidadPagada := club cantidadPagadaPor: 'Pablo'.
	
	" Assert "
	self assert: cantidadPagada equals: 1500! !

!PruebasClub methodsFor: 'tests' stamp: 'tomas 4/25/2020 11:41'!
test03SeAgreganDosSociosAlClubYLaCantidadDeSociosEsDos
	" Arrange "
	| socio1 socio2 cantidadDeSocios |
	
	socio1 := Socio new.
	socio1 establecerNombre: 'Carlos'.
	club agregarSocio: socio1.

	socio2 := Socio new.
	socio2 establecerNombre: 'Marcio'.

	club agregarSocioVIP: socio2.
	
	" Act "
	cantidadDeSocios := club cantidadDeSocios.
	
	" Assert "
	self assert: cantidadDeSocios equals: 2! !

!PruebasClub methodsFor: 'tests' stamp: 'tomas 4/25/2020 11:41'!
test02SeAgreganDosSociosAlClubYSeDevuelveElConjuntoDeSusNombres
	" Arrange "
	| socio1 socio2 nombresSocios |
	
	socio1 := Socio new.
	socio1 establecerNombre: 'Carlos'.
	club agregarSocio: socio1.

	socio2 := Socio new.
	socio2 establecerNombre: 'Marcio'.

	club agregarSocioVIP: socio2.
	
	" Act "
	nombresSocios := club nombresSocios.
	
	" Assert "
	self assertCollection: nombresSocios equals: (Set withAll: #('Marcio' 'Carlos'))! !

!PruebasClub methodsFor: 'tests' stamp: 'tomas 4/25/2020 11:41'!
test05SeAgreganTresSociosAlClubYLaCantidadDeSociosEsTres
	" Arrange "
	| socio1 socio2 socio3 cantidadDeSocios |
	
	socio1 := Socio new.
	socio1 establecerNombre: 'Carlos'.
	club agregarSocio: socio1.

	socio2 := Socio new.
	socio2 establecerNombre: 'Marcio'.

	club agregarSocioVIP: socio2.
	
	socio3 := Socio new.
	socio3 establecerNombre: 'Pablo'.

	club agregarSocio: socio3.
	
	" Act "
	cantidadDeSocios := club cantidadDeSocios.
	
	" Assert "
	self assert: cantidadDeSocios equals: 3! !

!PruebasClub methodsFor: 'tests' stamp: 'tomas 4/25/2020 11:46'!
test10SeAgreganDosSociosComunesYOtroVipYRealizanSietePagosComunYLaCantidadPagadaPorElPrimerSocioComunEs2000
	" Arrange "
	| socio1 socio2 socio3 cantidadPagada |
	
	socio1 := Socio new.
	socio1 establecerNombre: 'Carlos'.

	socio2 := Socio new.
	socio2 establecerNombre: 'Marcio'.

	socio3 := Socio new.
	socio3 establecerNombre: 'Pablo'.

	club agregarSocio: socio1; agregarSocioVIP: socio2; agregarSocio: socio3.
	
	4 timesRepeat: [ 
		club recibirPagoDe: 'Carlos'. " 500 "
		club recibirPagoDe: 'Marcio'. " 700 "
	].

	3 timesRepeat: [ 
		club recibirPagoDe: 'Pablo'.  " 500 "
	].
	
	" Act "
	cantidadPagada := club cantidadPagadaPor: 'Carlos'.
	
	" Assert "
	self assert: cantidadPagada equals: 2000! !

!PruebasClub methodsFor: 'tests' stamp: 'tomas 4/25/2020 11:41'!
test07SeAgreganDosSociosComunesYOtroVipYRealizanTresPagosCadaUnoYLaRecaudacionTotalEs5100
	" Arrange "
	| socio1 socio2 socio3 recaudacionTotal |
	
	socio1 := Socio new.
	socio1 establecerNombre: 'Carlos'.

	socio2 := Socio new.
	socio2 establecerNombre: 'Marcio'.

	socio3 := Socio new.
	socio3 establecerNombre: 'Pablo'.

	club agregarSocio: socio1; agregarSocioVIP: socio2; agregarSocio: socio3.
	
	3 timesRepeat: [ 
		club recibirPagoDe: 'Pablo'.  " 500 "
		club recibirPagoDe: 'Carlos'. " 500 "
		club recibirPagoDe: 'Marcio'. " 700 "
	].
	
	" Act "
	recaudacionTotal := club recaudacionTotal.
	
	" Assert "
	self assert: recaudacionTotal equals: 5100! !

!PruebasClub methodsFor: 'tests' stamp: 'tomas 4/25/2020 11:22'!
test01LaRecaudacionInicialDelClubDebeSerCero
	" Arrange "
	| recaudacion |
	
	" Act "
	recaudacion := club recaudacionTotal.
	
	" Assert "
	self assert: recaudacion equals: 0! !

!PruebasClub methodsFor: 'tests' stamp: 'tomas 4/25/2020 11:41'!
test04SeAgregaUnSocioComunYOtroVipYRealizanUnPagoCadaUnoYLaRecaudacionTotalEs1200
	" Arrange "
	| socio1 socio2 recaudacionTotal |
	
	socio1 := Socio new.
	socio1 establecerNombre: 'Carlos'.
	club agregarSocio: socio1.

	socio2 := Socio new.
	socio2 establecerNombre: 'Marcio'.

	club agregarSocioVIP: socio2.
	
	club recibirPagoDe: 'Carlos'.
	club recibirPagoDe: 'Marcio'.
	
	" Act "
	recaudacionTotal := club recaudacionTotal.
	
	" Assert "
	self assert: recaudacionTotal equals: 1200! !

!PruebasClub methodsFor: 'tests' stamp: 'tomas 4/25/2020 11:44'!
test09SeAgreganDosSociosComunesYOtroVipYRealizanSietePagosComunYLaCantidadPagadaPorElSocioVipEs2800
	" Arrange "
	| socio1 socio2 socio3 cantidadPagada |
	
	socio1 := Socio new.
	socio1 establecerNombre: 'Carlos'.

	socio2 := Socio new.
	socio2 establecerNombre: 'Marcio'.

	socio3 := Socio new.
	socio3 establecerNombre: 'Pablo'.

	club agregarSocio: socio1; agregarSocioVIP: socio2; agregarSocio: socio3.
	
	4 timesRepeat: [ 
		club recibirPagoDe: 'Carlos'. " 500 "
		club recibirPagoDe: 'Marcio'. " 700 "
	].

	3 timesRepeat: [ 
		club recibirPagoDe: 'Pablo'.  " 500 "
	].
	
	" Act "
	cantidadPagada := club cantidadPagadaPor: 'Marcio'.
	
	" Assert "
	self assert: cantidadPagada equals: 2800! !

!PruebasClub methodsFor: 'tests' stamp: 'tomas 4/25/2020 11:40'!
test08SeAgreganDosSociosComunesYOtroVipYRealizanSietePagosComunYCuatroVipYLaRecaudacionEs6300
	" Arrange "
	| socio1 socio2 socio3 recaudacionTotal |
	
	socio1 := Socio new.
	socio1 establecerNombre: 'Carlos'.

	socio2 := Socio new.
	socio2 establecerNombre: 'Marcio'.

	socio3 := Socio new.
	socio3 establecerNombre: 'Pablo'.

	club agregarSocio: socio1; agregarSocioVIP: socio2; agregarSocio: socio3.
	
	club recibirPagoDe: 'Carlos'. " 500 "
	club recibirPagoDe: 'Marcio'. " 700 "

	3 timesRepeat: [ 
		club recibirPagoDe: 'Pablo'.  " 500 "
		club recibirPagoDe: 'Carlos'. " 500 "
		club recibirPagoDe: 'Marcio'. " 700 "
	].
	
	" Act "
	recaudacionTotal := club recaudacionTotal.
	
	" Assert "
	self assert: recaudacionTotal equals: 6300! !

!PruebasClub methodsFor: 'tests' stamp: 'tomas 4/25/2020 11:31'!
test06SeAgreganTresSociosAlClubYSeDevuelveElConjuntoDeSusNombres
	" Arrange "
	| socio1 socio2 socio3 nombresSocios |
	
	socio1 := Socio new.
	socio1 establecerNombre: 'Carlos'.
	club agregarSocio: socio1.

	socio2 := Socio new.
	socio2 establecerNombre: 'Marcio'.

	club agregarSocioVIP: socio2.

	socio3 := Socio new.
	socio3 establecerNombre: 'Pablo'.

	club agregarSocio: socio3.
	
	" Act "
	nombresSocios := club nombresSocios.
	
	" Assert "
	self assertCollection: nombresSocios 
		equals: (Set withAll: #('Marcio' 'Carlos' 'Pablo'))! !


!PruebasClub methodsFor: 'running' stamp: 'tomas 4/25/2020 11:22'!
setUp
	club := Club new.
	club establecerNombre: 'Club Social y Deportivo Orientado a Objetos'.
	club establecerTarifaSocio: 500.
	club establecerTarifaSocioVIP: 700.! !


TestCase subclass: #PruebasSocio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tp0.5-Test'!

!PruebasSocio methodsFor: 'tests' stamp: 'RodrigoVargas 4/29/2020 05:38'!
test02SocioConIdentidad
	" Arrange "
	| unSocio |
	
	" Act "
	unSocio := Socio new.
	unSocio establecerNombre: 'pepito'.
	unSocio establecerTarifa: 500.
	
	" Assert "
	self assert:  (unSocio darNombre) equals: 'pepito'.
	self assert:  (unSocio darTarifa) equals: 500.
	self assert:  (unSocio cantidadDePagos) equals: 0.! !

!PruebasSocio methodsFor: 'tests' stamp: 'RodrigoVargas 4/29/2020 05:35'!
test01SocioSinIdentidad
	" Arrange "
	| unSocio |
	
	" Act "
	unSocio := Socio new.
	
	" Assert "
	self assert:  (unSocio darNombre) equals: ''.
	self assert:  (unSocio darTarifa) equals: 0.
	self assert:  (unSocio cantidadDePagos) equals: 0.! !

!PruebasSocio methodsFor: 'tests' stamp: 'RodrigoVargas 4/29/2020 05:45'!
test04SocioRealizo5Pagos
	" Arrange "
	| unSocio |
	
	" Act "
	unSocio := Socio new.
	unSocio establecerNombre: 'pepito'.
	unSocio establecerTarifa: 500.
	5 timesRepeat: [ 
		unSocio realizoUnPago.
	].
	
	" Assert "
	self assert:  (unSocio darNombre) equals: 'pepito'.
	self assert:  (unSocio darTarifa) equals: 500.
	self assert:  (unSocio cantidadDePagos) equals: 5.! !

!PruebasSocio methodsFor: 'tests' stamp: 'RodrigoVargas 4/29/2020 05:43'!
test03SocioRealizoUnPago
	" Arrange "
	| unSocio |
	
	" Act "
	unSocio := Socio new.
	unSocio establecerNombre: 'pepito'.
	unSocio establecerTarifa: 500.
	unSocio realizoUnPago.
	
	" Assert "
	self assert:  (unSocio darNombre) equals: 'pepito'.
	self assert:  (unSocio darTarifa) equals: 500.
	self assert:  (unSocio cantidadDePagos) equals: 1.! !


Object subclass: #Socio
	instanceVariableNames: 'nombreDelSocio tarifaDelSocio cantidadDePagos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tp0.5-Test'!

!Socio methodsFor: 'initialization' stamp: 'RodrigoVargas 4/29/2020 00:59'!
initialize

	nombreDelSocio := ''.
	tarifaDelSocio := 0.
	cantidadDePagos := 0.! !


!Socio methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/28/2020 03:30'!
darNombre

	^nombreDelSocio .! !

!Socio methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/29/2020 03:51'!
realizoUnPago
	cantidadDePagos := cantidadDePagos +1.! !

!Socio methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/29/2020 03:57'!
cantidadDePagos

	^cantidadDePagos! !

!Socio methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/29/2020 00:52'!
establecerTarifa: unaTarifa

	tarifaDelSocio := unaTarifa .

	! !

!Socio methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/29/2020 03:44'!
darTarifa

	^tarifaDelSocio! !

!Socio methodsFor: 'as yet unclassified' stamp: 'RodrigoVargas 4/27/2020 17:43'!
establecerNombre: unNombre

	nombreDelSocio := unNombre .! !
